<?php
/************************************************************************/
/*                                WEBSHARE                              */
/************************************************************************/
//
// Copyright (c) 2008 by Virginie Vivancos
// http://www.webshare.fr
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License.
//
// =======================================================================
// Fonction : Récupère la progression de l'upload
// Nom      : upload_progress.php
// Version  : 0.6.5
// Date     : 28/05/08
// =======================================================================

include_once "auth.php";
include_once "fonctions.php";
include_once "connexion.conf.php";

$nomSrv= $_SESSION["serveurActif"];
$chemin= blindeChemin(blindeChemin($_SESSION["cheminActif"]."/".$_SESSION["dossierActif"]."/"));

if (isset($_GET["filename"])) {
  $_SESSION["dl"]    = 0;
  $_SESSION["finDl"] = 0;
  $_SESSION["typeZip"]    = $_GET["typeZip"];
  $_SESSION["typeAction"] = $_GET["typeAction"];
  $_SESSION["fileName"]   = $_GET["filename"];
  $_SESSION["nomEncode"]  = urldecode(stripslashes(basename(blindeChemin($_GET["nomEncode"]))));
  if (empty($_SESSION["nomEncode"]))  $_SESSION["nomEncode"] = $_SESSION["fileName"];
}
$nomEnvoi= preg_replace("/%u([0-9ABCDEFabcdef]{3,5})/e", 'html_to_utf8("\\1")', $_SESSION["nomEncode"]);
$statFile= $_SESSION["tempDir2"]."/stats_".$_SESSION["sid"].".txt";
$statInfo= file_get_contents($statFile);

if (isset($statInfo)&&(strlen($statInfo)!=0)) {
  $etat="D"; $_SESSION["dl"]=1;
  $pourcent= substr($statInfo,0,strpos($statInfo,"|"));
  if ($pourcent=="100")   { $etat="S"; $_SESSION["finDl"] = 1; }
  if ($pourcent=="-1")    { $etat="P"; $_SESSION["finDl"] = 1; }
} else {
  $etat="W";
  if ($_SESSION["dl"]!=0) { $etat="S"; $_SESSION["finDl"] = 1; }
}

if ($_SESSION["finDl"]==1) {

  if ($pourcent=="100") {
    if ((strstr($_SESSION["fileName"],".zip")!==false) && ($_SESSION["typeZip"]==1)) {
      dezipper(blindeChemin($_SESSION["tempDir2"].$_SESSION["fileName"]),blindeChemin($chemin));
    } else {
	    move_uploaded_file($_SESSION["fileName"],$_SESSION["tempDir2"]);
      if ((preg_match($_SESSION["varsUser"],$_SESSION["fileName"]))==0) {
       $lienSrv= blindeChemin($_SESSION["tempDir2"]);
       $handle = opendir($lienSrv);

       while (false !== ($entry = readdir($handle))) {
         if (preg_match(str_replace("/i","|stats_|temp_/i",$_SESSION["varsUser"]), $entry)==0) {

           if (!is_dir($lienSrv.blindeChemin("/$entry"))) {
		   $temp = blindeChemin($_SESSION["tempDir2"].$_SESSION["nomEncode"]);//$entry);
           $dest = blindeChemin($chemin).$_SESSION["nomEncode"];

             $_SESSION["$nomSrv"]["connexion"]=connexionFTP($nomSrv,$_SESSION["pts"]);
             $existing= 0;

             if (($contents = ftp_rawlist($_SESSION["$nomSrv"]["connexion"], $chemin))!==FALSE) {
		     foreach($contents as $file) {
                 if (preg_match("/^[.]{2}$|^[.]{1}$/", $file)==0) {
                   $info = array();
                   $vinfo = preg_split("/[\s]+/", $file, 9);
                   if ($vinfo[0] !== "total") {
                     $filename = $vinfo[8];
                     if (preg_match("/".$_SESSION["nomEncode"]."/",$filename)==1) $existing=1;continue; }
                 }
               }
             }

             switch ($_SESSION["typeAction"]) {
	     default: case "0":
		     if ($existing) @ftp_delete($_SESSION["$nomSrv"]["connexion"],$dest);
		     get_pt();
               $ftp_reponse =  $ftp_reponse = @ftp_put($_SESSION["$nomSrv"]["connexion"],$dest,$temp, FTP_BINARY);
		     break;

	     case "1":
		     get_pt();
               if ($existing)  $ftp_reponse = @ftp_put($_SESSION["$nomSrv"]["connexion"],blindeChemin($chemin).date("Ymd_His_").$_SESSION["nomEncode"],$temp, FTP_BINARY);
	       else $ftp_reponse = @ftp_put($_SESSION["$nomSrv"]["connexion"],$dest,$temp, FTP_BINARY);
               break;

             case "2":

		     if (!$existing) $ftp_reponse = @ftp_put($_SESSION["$nomSrv"]["connexion"],$dest,$temp, FTP_BINARY);
               break;
             }

	     //FIXME :  envole : avoir un message d'erreur si un fichier est recopié dans un dossier ne possédant pas les droits en écriture
	     if($ftp_reponse==false) {$etat="P"; $statInfo="-1| Non téléchargé - Le dossier ne possède pas les droits en écriture ou Quota dépassé.";}

          logAction("6","2",$_SESSION["dia"]["File"]." ".$nomEnvoi." ".$_SESSION["dia"]["uploaded"],$_SESSION["nomUser"],$_SESSION["dossierActif"],$nomEnvoi,"");

         }
         }
       }
         closedir($handle);
      }
      else {
         $statInfo=$_SESSION["dia"]["noPermission"];
         unlink (blindeChemin($_SESSION["tempDir2"].$_SESSION["fileName"]));
      }
    }
  }

  unlink ($temp);
  unlink (blindeChemin($_SESSION["tempDir2"]."stats_".$_SESSION["sid"].".txt"));
  unlink (blindeChemin($_SESSION["tempDir2"]."temp_".$_SESSION["sid"]));
  $_SESSION["finDl"]==0;
}
echo $etat."|".$_SESSION["nomEncode"]."|".$statInfo."|End";

?>
